//
//  FriendsPresenter.swift
//  VK Tosters
//
//  Created programmist_np on 21/01/2020.
//  Copyright © 2020 programmist_np. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import RealmSwift
import Reachability
import SwiftyJSON

struct ResponseState {
    static var isLoaded: Bool = false
}

class FriendsPresenter: FriendsPresenterProtocol {
    weak private var view: FriendsViewProtocol?
    var interactor: FriendsInteractorProtocol?
    private let router: FriendsWireframeProtocol
    let realm = try! Realm()
    let reachability = try? Reachability()

    init(interface: FriendsViewProtocol, interactor: FriendsInteractorProtocol?, router: FriendsWireframeProtocol) {
        self.view = interface
        self.interactor = interactor
        self.router = router
    }
    
    deinit {
        ResponseState.isLoaded = false
        print("FriendsPresenter deinited")
    }
    
    var isReachable: Bool {
        if reachability?.connection == Reachability.Connection.unavailable {
            return false
        } else {
            return true
        }
    }
    
    func start(request: FriendModel.Request.RequestType) {
        interactor?.start(request: request)
    }
    
    func presentData(response: FriendModel.Response.ResponseType) {
        switch response {
        case .presentFriend(response: let response):
            let cells = response.items?.compactMap { (item) in
                friendCellViewModel(from: item)
            }
            
            let friendViewModel = FriendViewModel.init(cell: cells ?? [], footerTitle: "")
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFriend(friendViewModel: friendViewModel))
            }
        case .presentFooterLoader:
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterLoader)
            }
        case .presentFooterError(message: let messageError):
            DispatchQueue.main.async {
                self.view?.displayData(viewModel: .displayFooterError(message: messageError))
            }
        }
    }
    
    private func friendCellViewModel(from friend: FriendItem) -> FriendViewModel.Cell {
        let friendCellViewModel = FriendViewModel.Cell.init(id: friend.id, firstName: friend.firstName, lastName: friend.lastName, isClosed: friend.isClosed, isOnline: friend.onlineInfo?.isOnline, isMobile: friend.onlineInfo?.isMobile, photo100: friend.photo100, school: friend.schools?[0].name, homeTown: friend.homeTown)
        return friendCellViewModel
    }
    
    
   func onError(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.2, execute: {
            self.onEvent(message: message, style)
        })
    }
    
    func onEvent(message: String, _ style: MessageViewState) {
        DispatchQueue.main.asyncAfter(deadline: .now() + 0.1, execute: {
            self.view?.showStatusError(message: message, error: nil, style, with: false)
        })
    }
    
    func onErrorConnection() {
        DispatchQueue.main.async {
            self.view?.showErrorConnection()
        }
    }
    
    func onTapFriend(userId: Int) {
        router.openProfile(userId: userId)
    }
    
    func onTapToChat(peerId: Int) {
        let realm = try! Realm()
        if let conversation = realm.objects(Conversation.self).filter("peerId == %@", peerId).first {
            self.router.openChat(from: conversation)
        } else {
            Api.Messages.getConversationById(peerId: peerId, isExtended: true, success: { [weak self] (item) in
                guard let self = self else { return }
                DispatchQueue.main.asyncAfter(deadline: .now() + 0.1, execute: {
                    let conversation = Conversation(conversation: item.0, lastMessage: JSON.null)
                    self.router.openChat(from: conversation)
                })
            }, error: { (error) in
                DispatchQueue.main.asyncAfter(deadline: .now() + 0.1, execute: {
                    self.view?.showStatusError(message: "Не удалось создать переписку", error: nil, .error, with: false)
                })
            })
        }
    }
}
